unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btAdd: TButton;
    btDel: TButton;
    btLoad: TButton;
    btSave: TButton;
    btNew: TButton;
    edName: TEdit;
    lKlasse: TLabel;
    lbNames: TListBox;
    opd: TOpenDialog;
    svd: TSaveDialog;
    procedure btAddClick(Sender: TObject);
    procedure btDelClick(Sender: TObject);
    procedure btLoadClick(Sender: TObject);
    procedure btNewClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure lbNamesSelectionChange(Sender: TObject; User: boolean);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btLoadClick(Sender: TObject);
begin
  if opd.Execute then begin
    lbNames.Items.LoadFromFile(opd.FileName);
  end;
end;

procedure TForm1.btAddClick(Sender: TObject);
begin
  if lbNames.Items.IndexOf(edName.Text) = -1 then begin
    lbNames.Items.Add(edName.Text);
  end;
end;

procedure TForm1.btDelClick(Sender: TObject);
begin
  if lbNames.Items.IndexOf(edName.Text) >= 0 then begin
    lbNames.Items.Delete(lbNames.Items.IndexOf(edName.Text));
  end;
end;

procedure TForm1.btNewClick(Sender: TObject);
begin
  lbNames.Clear;
end;

procedure TForm1.btSaveClick(Sender: TObject);
begin
  if (svd.Execute) and (lbNames.Count<=0) then begin
    lbNames.Items.SaveToFile(svd.FileName);
  end;
end;

procedure TForm1.lbNamesSelectionChange(Sender: TObject; User: boolean);
begin
  edName.Text := lbNames.Items[lbNames.ItemIndex];
end;

end.

