unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btAdd: TButton;
    btDel: TButton;
    btLoad: TButton;
    btSave: TButton;
    btNew: TButton;
    edName: TEdit;
    lKlasse: TLabel;
    lbNames: TListBox;
    opd: TOpenDialog;
    svd: TSaveDialog;
    procedure btAddClick(Sender: TObject);
    procedure btDelClick(Sender: TObject);
    procedure btLoadClick(Sender: TObject);
    procedure btNewClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure lbNamesSelectionChange(Sender: TObject; User: boolean);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btLoadClick(Sender: TObject);
var f: Textfile;
    l: String;
begin
  if opd.Execute then begin
    assignfile(f, opd.FileName);
    reset(f);
    lbNames.clear;
    while not eof(f) do begin
      readln(f, l);
      lbNames.Items.Add(l);
    end;
    closefile(f);
  end;
end;

procedure TForm1.btAddClick(Sender: TObject);
begin
  if lbNames.Items.IndexOf(edName.Text) = -1 then begin
    lbNames.Items.Add(edName.Text);
  end;
end;

procedure TForm1.btDelClick(Sender: TObject);
begin
  if lbNames.Items.IndexOf(edName.Text) >= 0 then begin
    lbNames.Items.Delete(lbNames.Items.IndexOf(edName.Text));
  end;
end;

procedure TForm1.btNewClick(Sender: TObject);
begin
  lbNames.Clear;
end;

procedure TForm1.btSaveClick(Sender: TObject);
var f: Textfile;
    i: Integer;
begin
  if (svd.Execute) and (lbNames.Count>0) then begin
    assignfile(f, svd.FileName);
    rewrite(f);
    for i:=0 to lbNames.Count-1 do begin
      writeln(f, lbNames.Items[i]);
    end;
    closefile(f);
  end;
end;

procedure TForm1.lbNamesSelectionChange(Sender: TObject; User: boolean);
begin
  edName.Text := lbNames.Items[lbNames.ItemIndex];
end;

end.

