unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  TSchueler = record
    LName: string[30];
    FName: string[12];
    Avg: real;
    ism: boolean;
  end;

  { TForm1 }
  TForm1 = class(TForm)
    BtNext: TButton;
    BtVor: TButton;
    BtLoad: TButton;
    BtSave: TButton;
    BtClear: TButton;
    BtEnd: TButton;
    BtAnf: TButton;
    BtAdd: TButton;
    BtChg: TButton;
    BtDel: TButton;
    cmbxmw: TComboBox;
    edDurch: TEdit;
    ednn: TEdit;
    edvn: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    llAusg: TLabel;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    procedure BtAddClick(Sender: TObject);
    procedure BtAnfClick(Sender: TObject);
    procedure BtChgClick(Sender: TObject);
    procedure BtDelClick(Sender: TObject);
    procedure BtEndClick(Sender: TObject);
    procedure BtLoadClick(Sender: TObject);
    procedure BtClearClick(Sender: TObject);
    procedure BtNextClick(Sender: TObject);
    procedure BtSaveClick(Sender: TObject);
    procedure BtVorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    arS: array of TSchueler;
    idx: Cardinal;
    procedure refreshForm();
    procedure changeArray();
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.BtLoadClick(Sender: TObject);
var f: file of TSchueler;
    S: TSchueler;
begin
  if OpenDlg.execute then begin
    assignfile(f, OpenDlg.filename);
    reset(f);
    idx:=0;
    while not eof(f) do begin
      read(f, S);
      setlength(arS, idx+1);
      arS[idx] := S;
      idx+=1;
    end;
    idx-=1;
    refreshForm();
    closefile(f);
  end;
end;

procedure TForm1.BtSaveClick(Sender: TObject);
var f: file of TSchueler;
    i: Integer;
begin
  if SaveDlg.execute then begin
    assignfile(f, SaveDlg.filename);
    rewrite(f);
    for i:=0 to length(arS)-1 do begin
      write (f, arS[i]);
    end;
    closefile(f);
  end;
end;

procedure TForm1.BtClearClick(Sender: TObject);
begin
  idx:=length(arS);
  refreshForm();
end;

procedure TForm1.BtEndClick(Sender: TObject);
begin
  idx:=length(arS)-1;
  refreshForm();
end;

procedure TForm1.BtAnfClick(Sender: TObject);
begin
  idx:=0;
  refreshForm();
end;

procedure TForm1.BtChgClick(Sender: TObject);
begin
  changeArray();
end;

procedure TForm1.BtDelClick(Sender: TObject);
var i: Cardinal;
begin
  for i := idx to length(arS)-1 do begin
    arS[i] := arS[i+1];
  end;
  setLength(arS, i);
  if idx > length(arS)-1 then begin
     idx := length(arS)-1;
  end;
  refreshForm();
end;

procedure TForm1.BtAddClick(Sender: TObject);
begin
  idx:=length(arS);
  setlength(arS, idx+1);
  changeArray();
end;

procedure TForm1.BtNextClick(Sender: TObject);
begin
  if idx < length(arS)-1 then begin
    idx+=1;
    refreshForm();
  end;
end;

procedure TForm1.BtVorClick(Sender: TObject);
begin
  if idx > 0 then begin
    idx-=1;
    refreshForm();
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  idx:=0;
end;

procedure TForm1.changeArray();
begin
 arS[idx].LName:=ednn.Caption;
 arS[idx].FName:=edvn.Caption;
 arS[idx].Avg:=StrToFloat(edDurch.Caption);
 if cmbxmw.Caption = 'm' then begin
   arS[idx].ism:=true;
 end else if cmbxmw.Caption = 'w' then begin
   arS[idx].ism:=false;
 end;
end;

procedure TForm1.refreshForm();
var p, g: String;
begin
 if idx<length(arS) then begin
 ednn.Text:=arS[idx].LName;
 edvn.Text:=arS[idx].FName;
 edDurch.Text:=FloatToStr(arS[idx].Avg);
 if arS[idx].ism then begin
   cmbxmw.Text:='m';
 end else begin
   cmbxmw.Text:='w';
 end;
 if arS[idx].Avg<2 then begin
   p:=' und erhält einen Preis.';
 end else begin
    p:='.'
 end;
 if arS[idx].ism then begin
   g:='Er ';
 end else begin
     g:='Sie ';
 end;
 if arS[idx].Avg<4 then begin
   llAusg.Caption:=g+'wird versetzt'+p;
 end else begin
   llAusg.Caption:=g+'wird nicht versetzt.';
 end;
 end else begin
   ednn.Text:='';
   edvn.Text:='';
   edDurch.Text:='';
   cmbxmw.Text:='';
 end;
end;

end.

