unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Math;

const d = 40; p0=40; q0=200;//***

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    pbx: TPaintBox;
    rg: TRadioGroup;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
    procedure pbxPaint();
    function f(x:real):real;  // Quadratfunktion
    function g(x:real):real;  // Sinusfunktion
    function h(x:real):real;  // gebrochenrationale Funktion
    function p(x:real):integer; // Transformation math-x-->Pixel horizontal (p)
    function q(y:real):integer; // Transformation math-y-->Pixel vertikal (q)
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}


procedure TForm1.Button1Click(Sender: TObject);
var x: Real;
begin
  x:=0.01;
  pbxPaint();
  pbx.canvas.moveto(p0,q0);
  while x<=6.51 do begin
    case rg.ItemIndex of
         0: pbx.canvas.lineto(p(x),q(f(x)));
         1: pbx.canvas.lineto(p(x),q(g(x)));
         2: pbx.canvas.lineto(p(x),q(h(x)));
    end;
    x+=0.1;
  end;
end;

procedure TForm1.pbxPaint();
var i: Integer;
    si: String;
begin
   with pbx.canvas do begin
     Repaint; // clear

     moveto(p0,q0); // +
     lineto(p(6.5),q0);
     moveto(p0,q0);
     lineto(p0,q(6.5));

     Brush.color:=clBtnFace; // Achsenbeschrifung
     for i:=1 to 6 do begin
       si:=IntToStr(i);
       moveto(p(i),q0);
       lineto(p(i),q0+3);
       textout(p(i) - textwidth(si) div 2,q0+3,si);
     end;
     for i:=1 to 4 do begin
       si:=IntToStr(i);
       moveto(p0,q(i));
       lineto(p0-3,q(i));
       textout(p0 - textwidth(si) - i, q(i) - textheight(si) div 2, si);
     end;
   end;
end;

//mathematische Funktionen
function TForm1.f(x:real):real;
begin
  result:=0.1*power(x,2);
end;

function TForm1.g(x:real):real;
begin
  result:=2+2*sin(pi/3*x);
end;

function TForm1.h(x:real):real;
begin
  result:=2/3*x+1/x;
end;

//Transformation: Mathemat Koord (x,y) in Pixelkoord (p,q)
function TForm1.p(x:real):integer;
begin
  result:=p0+round(d*x);
end;

function TForm1.q(y:real):integer;
begin
  result:=q0-round(d*y);
end;

end.

